@echo off
rem # ------------------------------------------------------------
rem # Company: Software- und Organisations-Service GmbH
rem # Author : Oliver Haufe <oliver.haufe@sos-berlin.com>
rem # ------------------------------------------------------------

SETLOCAL
set SCHEDULER_HTTP_PORT=%~1
set SCHEDULER_LOG_DIR=%~2
set /a SCHEDULER_SERVICE_IS_RUNNING=0
set /a SCHEDULER_SERVICE_EXIST=1

if not defined SCHEDULER_HTTP_PORT (
  echo Please enter the http port of the JobScheduler Agent
  goto usage
)
goto uninstall

:usage
echo Usage: %~nx0 http-port [log_dir]
call :more_info
echo.
pause
exit /b 0

:more_info
echo see also https://kb.sos-berlin.com/x/kQiX for more information.
goto final

:normalize_home
set SCHEDULER_HOME=%~dp1
set SCHEDULER_HOME=%SCHEDULER_HOME:~0,-1%
goto final

:clear
if exist "%SERVICE_MANAGER%" del "%SERVICE_MANAGER%"
if exist "%SERVICE_INSTALL%" del "%SERVICE_INSTALL%"
goto final

:service_exist
sc.exe query %SERVICE_NAME% > nul
if %ERRORLEVEL% EQU 1060 set /a SCHEDULER_SERVICE_EXIST=0
goto final

:service_is_running
for /F "usebackq tokens=3 delims=: " %%i in (`sc.exe query %SERVICE_NAME% ^| findstr /I "STATE"`) do (
  if /I x%%i==xRUNNING set /a SCHEDULER_SERVICE_IS_RUNNING=1
)
goto final

:uninstall
set SCHEDULER_HOME=%~dp0..
call :normalize_home "%SCHEDULER_HOME%\dummy"
if not defined SCHEDULER_LOG_DIR set SCHEDULER_LOG_DIR=%SCHEDULER_HOME%\logs
set SERVICE_NAME=sos_jobscheduler_agent_%SCHEDULER_HTTP_PORT%
set SERVICE_INSTALL_TEMPLATE=%SCHEDULER_HOME%\service\%PROCESSOR_ARCHITECTURE%\prunsrv.exe
set SERVICE_INSTALL=%SCHEDULER_HOME%\service\%SERVICE_NAME%.exe
set SERVICE_MANAGER=%SCHEDULER_HOME%\service\%SERVICE_NAME%w.exe

call :service_exist
if %SCHEDULER_SERVICE_EXIST% equ 0 (
  echo "%SERVICE_NAME%" service doesn't exist.
  exit /B 0
) 
if not exist "%SERVICE_INSTALL%" (
  echo the daemon "%SERVICE_INSTALL%" for the "%SERVICE_NAME%" service doesn't exist.
  echo ...try to copy "%SERVICE_INSTALL_TEMPLATE%" to "%SERVICE_INSTALL%"
  copy /Y "%SERVICE_INSTALL_TEMPLATE%" "%SERVICE_INSTALL%"
  if ERRORLEVEL 1 exit /B %ERRORLEVEL%
)
call :service_is_running
if %SCHEDULER_SERVICE_IS_RUNNING% equ 1 "%SERVICE_INSTALL%" //SS/%SERVICE_NAME% 
"%SERVICE_INSTALL%" //DS/%SERVICE_NAME% 
 
if not errorlevel 1 (
  echo "%SERVICE_NAME%" service has been deleted
  call :clear
  goto final
)
echo Failed to delete "%SERVICE_NAME%" service. Refer to log in %SCHEDULER_LOG_DIR%

ENDLOCAL
:final